/* Problema: det. laturii maxime L a unei submatrice patratica a[][] care contine
 *           numai valori de 1   
 * 
 * Algoritm de Programare Dinamica
 * 
 * 	Declaram matricea:
 * 	int L[1001][1001];  // L[i][j] = latura maxima a unui patrat care contine
 *                      // numai valori de 1, care poate fi plasat cu coltul 
 *                      // dreapta jos la linia i si coloana j
 */ 

#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("submatrix.in");
ofstream fout("submatrix.out");


const int Dim = 1001;
int a[Dim][Dim];  // matricea care se citeste
int L[Dim][Dim];  // L[i][j] = latura maxi,a a unui patrat cu coltul
                  // dreapta jos la linia i si coloana j

int Lmax;         // latura maxima ceruta                 
int n;

void CitesteMatrice();
void Rezolva();


int main()
{
	CitesteMatrice();
	Rezolva();
	
	fout << Lmax;
}  

void Rezolva()
{
	// matricea L se calculeaza dinamic, pe baza unei relatii recurente

	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			if (a[i][j] == 0)
				L[i][j] = 0; // nu pot plasa un patrat cu coltul dreapta jos aici
			else
			{
				L[i][j] = 1 + min({L[i - 1][j], L[i - 1][j - 1], L[i][j - 1]});
				Lmax = max(Lmax, L[i][j]);
			}
}

void CitesteMatrice()
{
	fin >> n;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			fin >> a[i][j];
}












