/* Problema: 
 * 		Se da o matrice de numere intregi a[][] de dimensiune  n x m si un
 *      set de Q query-uri (intrebari) de forma:
 * 		i1 j1 i2 j2 
 *      reprezentand coltul stanga-su, respectiv coltul dreapta-jos
 *      ale unei submatrice.
 * 
 *      Pentru fiecare query (intrebare) sa se scrie suma valorilor din submatricea data.
 * 
 *     Restrictii
 * 		1 <= n, m <= 1000	
 * 		1 <= Q <= 100000
 * 
 * 	Algoritmul naiv (Brute-Force) : O(Q * n^2)
 * 
 * 	Algoritmul OPTIM: - raspundem la fiecare intrebare in timp constant: O(1)
 * 
 *  	O(n^2 + Q)
 * 	
 */ 

#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("submatrix.in");
ofstream fout("submatrix.out");


const int Dim = 1001;
int a[Dim][Dim];   // matricea care se citeste
int n, m;
int Q;   // numarul de intebari (query-uri)

// Calculam aceasta matrice dinamic (bazat pe o relatie recurenta)
int s[Dim][Dim];   // s[i][j] = suma dreptunghiului avand coltul stanga-sus (1,1) si 
                   // si coltul dreapta-jos la (i, j)


void CitesteMatrice();
void Rezolva();

// Solutie de complexitate: O(n^2 + Q)

int main()
{
	CitesteMatrice(); // O(n^2)
	Rezolva();        // O(Q)
	
	return 0;	
}  

void Rezolva()
{
	int i1, j1, i2, j2;
	for (int i = 1; i <= Q; ++i) // O(Q)
	{
		fin >> i1 >> j1 >> i2 >> j2;
		
		fout << s[i2][j2] - s[i1 - 1][j2] - s[i2][j1 - 1] + 
			    s[i1 - 1][j1 - 1] << '\n';
	}
}

void CitesteMatrice()
{
	fin >> n >> m >> Q;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
		{
			fin >> a[i][j];
			
			s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + a[i][j];
		}
		

}












